'use strict';

var through = require('through2');
var spider = require('spider-script');
var gutil = require('gulp-util');

var PLUGIN_NAME = 'gulp-spider';
var PluginError = gutil.PluginError;

module.exports = function (opt) {
  function replaceExt(path) {
    return gutil.replaceExtension(path, '.js');
  }

  function compile(file, enc, cb) {
    if (file.isNull()) return cb(null, file);
    if (file.isStream()) return cb(new PluginError(PLUGIN_NAME, 'Streaming not supported'));

    var data;
    var str = file.contents.toString('utf8');
    var dest = replaceExt(file.path);

    // onward to js
    try {
      data = spider.compile(str);
    } catch(err) {
      return cb(new PluginError(PLUGIN_NAME, err));
    }

    if (data) {
      file.contents = new Buffer(data);
    }

    file.path = dest;
    cb(null, file);
  }

  return through.obj(compile);
};
